package asmc

import (
	"git.urbach.dev/cli/q/src/asm"
	"git.urbach.dev/cli/q/src/x86"
)

func (c *compiler) load(x asm.Instruction) {
	switch x.Type {
	case asm.TypeMemoryRegister:
		operands := c.assembler.Param.MemoryRegister[x.Index]

		if operands.Address.OffsetRegister < 0 {
			c.code = x86.LoadRegister(c.code, operands.Register, operands.Address.Base, operands.Address.Offset, operands.Address.Length)
		} else {
			c.code = x86.LoadDynamicRegister(c.code, operands.Register, operands.Address.Base, operands.Address.OffsetRegister, operands.Address.Length)
		}
	}
}
