package eval

import (
	"git.urbach.dev/cli/q/src/cpu"
	"git.urbach.dev/cli/q/src/types"
)

// Register is a value that is stored inside a CPU register.
type Register struct {
	Typ      types.Type
	Alive    uint8
	Register cpu.Register
}

func (v *Register) String() string {
	return "Register"
}

func (v *Register) Type() types.Type {
	return v.Typ
}

// IsAlive returns true if the register value is still alive.
func (v *Register) IsAlive() bool {
	return v.Alive > 0
}

// Use reduces the lifetime counter by one.
func (v *Register) Use() {
	if v.Alive == 0 {
		panic("incorrect number of value use calls")
	}

	v.Alive--
}
